;              ======
; ,       
;  -    Aivan_2008,  FO_Games.
;         \ .
;           e-mail Aivan_2008@mail.ru,
;        .

Type TMenuItem
	Field Num
	Field Name$
	Field x,y
	Field ImageNorm
	Field ImageMouseOn
	Field imageClick
	Field State% ; - 0 - , 1 - , 2 - 
End Type

Global ActiveMenuNum% = -1
Global mx = 0
Global my = 0
Global ml_Hit# = False
Global Cur
Global mdflag

;////////////////////////////////////////////////////////
Function LoadMenuCursor(filename$)
	If Cur = 0 Then Cur = LoadImage(filename$)
End Function
;////////////////////////////////////////////////////////
Function GetStateByNumber(Num%)
	For m.tmenuitem = Each tmenuitem
		If m\Num = Num Then Return m\state
	Next
	Return -1
End Function
;////////////////////////////////////////////////////////
Function GetStateByName(Name$)
	For m.tmenuitem = Each tmenuitem
		If m\Name$ = Name$ Then Return m\state
	Next
	Return -1
End Function
;////////////////////////////////////////////////////////
Function UpdateMenu()
	ActiveMenuNum = -1
	UpdateMenuInput()
	DrawMenu()
	DrawImage Cur,mx,my
	
	If mdflag = 1 And ml_hit = False Then
		ClearMenu()
		Return ActiveMenuNum
	EndIf	

	If ActiveMenuNum>=0 And ml_Hit Then
		mdflag = 1
	Else
		mdflag = 0
	EndIf
	Return -1
End Function
;////////////////////////////////////////////////////////
Function AddMenuItem(ItemNum,ItemName$,X,Y,ImagefileN$,ImagefileS$,ImagefileC$)
	Menu.TMenuItem = New TMenuItem
	Menu\Name = ItemName$
	Menu\Num = ItemNum
	Menu\x = X
	Menu\y = Y
	Menu\ImageNorm = LoadImage(ImagefileN$)
	Menu\ImageMouseOn = LoadImage(ImagefileS$)
	Menu\ImageClick = LoadImage(ImagefileC$)
End Function
;////////////////////////////////////////////////////////
Function DrawMenu()
	For Menu.TMenuItem = Each TMenuItem
		If Menu\Num = ActiveMenuNum Then
			If Not ml_Hit
				DrawImage Menu\ImageMouseOn,Menu\x,Menu\y
				Menu\State = 1
			Else
				DrawImage Menu\ImageClick,Menu\x,Menu\y
				Menu\State = 2
			EndIf	
		Else
			DrawImage Menu\ImageNorm,Menu\x,Menu\y
		EndIf	
	Next
End Function
;////////////////////////////////////////////////////////
Function UpdateMenuInput()
	mx = MouseX()
	my = MouseY()
	If MouseDown(1) Then ml_Hit# = True Else ml_Hit# = False
	For m.TMenuItem = Each TMenuItem
		If PointInRect(mx,my,m\x,m\y,ImageWidth(m\ImageNorm),ImageHeight(m\ImageNorm))=1 Then ActiveMenuNum% = m\Num
	Next
End Function
;////////////////////////////////////////////////////////
Function ClearMenu()
	For m.tmenuitem = Each tmenuitem
		FreeImage m\ImageNOrm
		FreeImage m\ImageMouseOn
		FreeImage m\ImageClick
	Next
	FreeImage cur
End Function
;////////////////////////////////////////////////////////
Function PointInRect(x1#, y1#, x2#, y2#, w#, h#)
	Local xw#, yw#
	xw = x2 + w
	yw = y2 + h
	If x1 >= x2 And y1 >= y2 And x1 <= xw And y1 <= yw Then
		Return 1
	EndIf
	Return 0
End Function
;////////////////////////////////////////////////////////